## menhir 20060615.dfsg

=== Makefile ===
##########################################################################
#                                                                        #
#  Menhir                                                                #
#                                                                        #
#  Franois Pottier and Yann Rgis-Gianas, INRIA Rocquencourt            #
#                                                                        #
#  Copyright 2005 Institut National de Recherche en Informatique et      #
#  en Automatique. All rights reserved. This file is distributed         #
#  under the terms of the Q Public License version 1.0, with the         #
#  change described in file LICENSE.                                     #
#                                                                        #
##########################################################################

# ----------------------------------------------------------------------------
# Locating the ocaml compilers.
# If ocamlfind is available, then it is used for that purpose.

CAMLC           := $(shell if which ocamlfind &>/dev/null ; \
                       then echo ocamlfind ocamlc ; \
		       elif which ocamlc.opt &>/dev/null ; \
                       then echo ocamlc.opt ; \
		       else echo ocamlc ; fi)

CAMLOPT         := $(shell if which ocamlfind &>/dev/null ; \
                       then echo ocamlfind ocamlopt ; \
		       elif which ocamlopt.opt &>/dev/null ; \
                       then echo ocamlopt.opt ; \
		       else echo ocamlopt ; fi)

CAMLDEP         := $(shell if which ocamlfind &>/dev/null ; \
                       then echo ocamlfind ocamldep ; \
		       elif which ocamldep.opt &>/dev/null ; \
                       then echo ocamldep.opt ; \
		       else echo ocamldep ; fi)

CAMLLEX         := ocamllex

CAMLYACC        := ocamlyacc -v

# ----------------------------------------------------------------------------
# Installation paths.

ifneq ($(findstring install,$(MAKECMDGOALS)),)
  ifndef PREFIX
    $(error Please define PREFIX.)
  endif
endif

# TEMPORARY GODIVA and Linux do not agree on the standard paths...

EXECUTABLE      := menhir
bindir          := ${PREFIX}/bin
docdir		:= ${PREFIX}/share/doc/$(EXECUTABLE)
libdir	        := ${PREFIX}/share/$(EXECUTABLE)
mandir          := ${PREFIX}/share/man/man1
MANS            := menhir.1
DOCS            := manual.pdf demos
LIBS            := standard.mly

# ----------------------------------------------------------------------------
# Common compilation rules.

.PHONY: all install uninstall versioncheck

COLD            += all install uninstall versioncheck

all: versioncheck bootstrap

-include Makefile.common

# ----------------------------------------------------------------------------
# Recording the standard library path that was chosen at installation
# time. Do not rely on $(libdir) or $(EXECUTABLE) here, because
# $(EXECUTABLE) is set to a different value than the one shown above
# during bootstrap stage one.

stdlib.ml:
	echo "let path = \"${PREFIX}/share/menhir\"" > stdlib.ml

# ----------------------------------------------------------------------------
# Installation.

install:
	mkdir -p $(bindir)
	mkdir -p $(libdir)
	mkdir -p $(docdir)
	mkdir -p $(mandir)
	install $(EXECUTABLE) $(bindir)
	install -m 644 $(LIBS) $(libdir)
	cp -r $(DOCS) $(docdir)
	cp -r $(MANS) $(mandir)

uninstall:
	rm -rf $(bindir)/$(EXECUTABLE)
	rm -rf $(libdir)
	rm -rf $(docdir)
	rm -rf $(mandir)

# ----------------------------------------------------------------------------
# Checking the version of the ocaml compiler.

versioncheck:
	@ echo Checking that $(CAMLOPT) is recent enough...
	@ $(CAMLOPT) str.cmxa check-ocaml-version.ml -o check-ocaml-version
	@ ./check-ocaml-version --verbose --gt "3.09"

=== demos/Makefile ===
##########################################################################
#                                                                        #
#  Menhir                                                                #
#                                                                        #
#  Franois Pottier and Yann Rgis-Gianas, INRIA Rocquencourt            #
#                                                                        #
#  Copyright 2005 Institut National de Recherche en Informatique et      #
#  en Automatique. All rights reserved. This file is distributed         #
#  under the terms of the Q Public License version 1.0, with the         #
#  change described in file LICENSE.                                     #
#                                                                        #
##########################################################################

DEMOS := calc calc-two

.PHONY: all clean

all:
	@for i in $(DEMOS) ; do \
	  $(MAKE) -C $$i $(MFLAGS) ; \
	done

clean:
	/bin/rm -f *~ .*~
	@for i in $(DEMOS) ; do \
	  $(MAKE) -C $$i $(MFLAGS) clean ; \
	done

=== demos/calc-two/Makefile ===
##########################################################################
#                                                                        #
#  Menhir                                                                #
#                                                                        #
#  Franois Pottier and Yann Rgis-Gianas, INRIA Rocquencourt            #
#                                                                        #
#  Copyright 2005 Institut National de Recherche en Informatique et      #
#  en Automatique. All rights reserved. This file is distributed         #
#  under the terms of the Q Public License version 1.0, with the         #
#  change described in file LICENSE.                                     #
#                                                                        #
##########################################################################

GENERATED       := tokens.ml tokens.mli algebraic.ml algebraic.mli reverse.ml reverse.mli lexer.ml
MODULES         := algebraic reverse lexer calc
EXECUTABLE      := calc
OCAMLDEPWRAPPER := ../ocamldep.wrapper
include ../Makefile.shared
$(eval $(call menhir_monomodule,tokens,--only-tokens))
$(eval $(call menhir_multimodule,algebraic,tokens.mly algebraic.mly,--external-tokens Tokens))
$(eval $(call menhir_multimodule,reverse,tokens.mly reverse.mly,--external-tokens Tokens))

## menhir 20070322.dfsg

=== Makefile ===
##########################################################################
#                                                                        #
#  Menhir                                                                #
#                                                                        #
#  Franois Pottier and Yann Rgis-Gianas, INRIA Rocquencourt            #
#                                                                        #
#  Copyright 2005 Institut National de Recherche en Informatique et      #
#  en Automatique. All rights reserved. This file is distributed         #
#  under the terms of the Q Public License version 1.0, with the         #
#  change described in file LICENSE.                                     #
#                                                                        #
##########################################################################

# ----------------------------------------------------------------------------
# Installation paths.

# TEMPORARY GODIVA and Linux do not agree on the standard paths...

ifndef PREFIX
  $(error Please define PREFIX)
endif

bindir          := ${PREFIX}/bin
docdir		:= ${PREFIX}/share/doc/menhir
libdir	        := ${PREFIX}/share/menhir
mandir          := ${PREFIX}/share/man/man1
MANS            := menhir.1
DOCS            := manual.pdf demos
LIBS            := standard.mly

# ----------------------------------------------------------------------------
# Common compilation rules.

.PHONY: all install uninstall

COLD            += all install uninstall

all: menhir

-include Makefile.common

# ----------------------------------------------------------------------------
# Recording the standard library path that was chosen at installation
# time.

stdlib.ml:
	echo "let path = \"${PREFIX}/share/menhir\"" > stdlib.ml

# ----------------------------------------------------------------------------
# Installation.

install:
	mkdir -p $(bindir)
	mkdir -p $(libdir)
	mkdir -p $(docdir)
	mkdir -p $(mandir)
	install menhir $(bindir)
	install -m 644 $(LIBS) $(libdir)
	cp -r $(DOCS) $(docdir)
	cp -r $(MANS) $(mandir)

uninstall:
	rm -rf $(bindir)/menhir
	rm -rf $(libdir)
	rm -rf $(docdir)
	rm -rf $(mandir)

## menhir 20071205.dfsg

=== Makefile ===
--- 
+++ 
@@ -63,5 +63,5 @@
 	rm -rf $(bindir)/menhir
 	rm -rf $(libdir)
 	rm -rf $(docdir)
-	rm -rf $(mandir)
+	rm -rf $(mandir)/$(MANS)

=== demos/Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 #                                                                        #
 ##########################################################################
 
-DEMOS := calc calc-two
+DEMOS := calc calc-two calc-param
 
 .PHONY: all clean
 
@@ -21,7 +21,7 @@
 	done
 
 clean:
-	/bin/rm -f *~ .*~
+	/bin/rm -f *~ .*~ *.omc
 	@for i in $(DEMOS) ; do \
 	  $(MAKE) -C $$i $(MFLAGS) clean ; \
 	done

=== demos/calc-param/Makefile ===
##########################################################################
#                                                                        #
#  Menhir                                                                #
#                                                                        #
#  Franois Pottier and Yann Rgis-Gianas, INRIA Rocquencourt            #
#                                                                        #
#  Copyright 2005 Institut National de Recherche en Informatique et      #
#  en Automatique. All rights reserved. This file is distributed         #
#  under the terms of the Q Public License version 1.0, with the         #
#  change described in file LICENSE.                                     #
#                                                                        #
##########################################################################

GENERATED       := parser.ml parser.mli lexer.ml tokens.ml tokens.mli
MODULES         := parser lexer calc
EXECUTABLE      := calc
OCAMLDEPWRAPPER := ../ocamldep.wrapper
include ../Makefile.shared
$(eval $(call menhir_monomodule,tokens,--only-tokens))
$(eval $(call menhir_multimodule,parser,tokens.mly parser.mly,--external-tokens Tokens))

=== demos/calc-two/Makefile ===
--- 
+++ 
@@ -17,5 +17,5 @@
 OCAMLDEPWRAPPER := ../ocamldep.wrapper
 include ../Makefile.shared
 $(eval $(call menhir_monomodule,tokens,--only-tokens))
-$(eval $(call menhir_multimodule,algebraic,tokens.mly algebraic.mly,--external-tokens Tokens))
-$(eval $(call menhir_multimodule,reverse,tokens.mly reverse.mly,--external-tokens Tokens))
+$(eval $(call menhir_multimodule,algebraic,tokens.mly algebraic.mly common.mly,--external-tokens Tokens))
+$(eval $(call menhir_multimodule,reverse,tokens.mly reverse.mly common.mly,--external-tokens Tokens))

=== demos/calc/Makefile ===
##########################################################################
#                                                                        #
#  Menhir                                                                #
#                                                                        #
#  Franois Pottier and Yann Rgis-Gianas, INRIA Rocquencourt            #
#                                                                        #
#  Copyright 2005 Institut National de Recherche en Informatique et      #
#  en Automatique. All rights reserved. This file is distributed         #
#  under the terms of the Q Public License version 1.0, with the         #
#  change described in file LICENSE.                                     #
#                                                                        #
##########################################################################

GENERATED       := parser.ml parser.mli lexer.ml
MODULES         := parser lexer calc
EXECUTABLE      := calc
OCAMLDEPWRAPPER := ../ocamldep.wrapper
include ../Makefile.shared
include ../Makefile.auto

## menhir 20090505.dfsg

=== Makefile ===
# This is the main Makefile that is shipped as part of the source package.
# Keep in mind that the hierarchy that is shipped is not identical to the
# hierarchy within the svn repository: some sub-directories are not shipped;
# the documentation is pre-built.

# The hierarchy that is shipped includes:
#   demos
#   menhir.1
#   manual.pdf
#   src
#   Makefile (this one)

# ----------------------------------------------------------------------------

# By default, we attempt to use ocamlfind (if present in the PATH), but it it
# is possible to prevent that externally by setting USE_OCAMLFIND to false.

ifndef USE_OCAMLFIND
  USE_OCAMLFIND = ocamlfind ocamlc -v >/dev/null 2>&1
endif

# ----------------------------------------------------------------------------
# Installation paths.

# TEMPORARY GODIVA and Linux do not agree on the standard paths...

ifndef PREFIX
  $(error Please define PREFIX)
endif

bindir          := ${PREFIX}/bin
docdir		:= ${PREFIX}/share/doc/menhir
libdir	        := ${PREFIX}/share/menhir
mandir          := ${PREFIX}/share/man/man1
MANS            := menhir.1
DOCS            := manual.pdf demos
MLYLIB          := src/standard.mly
MENHIRLIB       := menhirLib.cmi menhirLib.cmo menhirLib.cmx menhirLib.o

# ----------------------------------------------------------------------------
# Compilation.

.PHONY: all install uninstall

all: src/menhir

src/menhir: src/installation.ml
	$(MAKE) -C src -f Makefile
	$(MAKE) -C src -f Makefile lib

# Record some installation time settings within the menhir binary.

src/installation.ml:
	echo "let libdir = \"${libdir}\"" > $@
	if $(USE_OCAMLFIND) ; then \
	  echo "let ocamlfind = true" >> $@ ; \
	else \
	  echo "let ocamlfind = false" >> $@ ; \
	fi

# ----------------------------------------------------------------------------
# Installation.

install: src/menhir
	mkdir -p $(bindir)
	mkdir -p $(libdir)
	mkdir -p $(docdir)
	mkdir -p $(mandir)
	install src/menhir $(bindir)
	install -m 644 $(MLYLIB) $(libdir)
	cp -r $(DOCS) $(docdir)
	cp -r $(MANS) $(mandir)
	@cd src && if $(USE_OCAMLFIND) ; then \
	  echo Installing MenhirLib via ocamlfind. ; \
	  ocamlfind install menhirLib META $(MENHIRLIB) ; \
	else \
	  echo Installing MenhirLib manually. ; \
	  install -m 644 $(MENHIRLIB) $(libdir) ; \
	fi

uninstall:
	rm -rf $(bindir)/menhir
	rm -rf $(libdir)
	rm -rf $(docdir)
	rm -rf $(mandir)/$(MANS)
	@if $(USE_OCAMLFIND) ; then \
	  echo Un-installing MenhirLib via ocamlfind. ; \
	  ocamlfind remove menhirLib ; \
	fi

=== src/Makefile ===
.PHONY: clean lib

COLD         += clean

# ----------------------------------------------------------------------------
# Locating the ocaml compilers.
# If ocamlfind is available, then it is used for that purpose.

CAMLTOP         := ocaml

CAMLC           := $(shell if ocamlfind ocamlc -v >/dev/null 2>&1 ; \
                       then echo ocamlfind ocamlc ; \
		       elif ocamlc.opt -v >/dev/null 2>&1 ; \
                       then echo ocamlc.opt ; \
		       else echo ocamlc ; fi)

CAMLOPT         := $(shell if ocamlfind ocamlopt -v >/dev/null 2>&1 ; \
                       then echo ocamlfind ocamlopt ; \
		       elif ocamlopt.opt -v >/dev/null 2>&1 ; \
                       then echo ocamlopt.opt ; \
		       else echo ocamlopt ; fi)

CAMLDEP         := $(shell if ocamlfind ocamldep -version >/dev/null 2>&1 ; \
                       then echo ocamlfind ocamldep ; \
		       elif ocamldep.opt -version >/dev/null 2>&1 ; \
                       then echo ocamldep.opt ; \
		       else echo ocamldep ; fi)

CAMLDEPWRAPPER  := ../demos/ocamldep.wrapper

CAMLLEX         := ocamllex

CAMLYACC        := ocamlyacc -v

# -------------------------------------------------------------------------

# Compilation flags.

BFLAGS       := -g
OFLAGS       := -inline 1000
LNKBFLAGS    := -g
LNKOFLAGS    :=
BLIBS        := unix.cma
OLIBS        := unix.cmxa
PGFLAGS      := -v -lg 1 -la 1 -lc 1 --comment --infer --error-recovery --stdlib .

# -------------------------------------------------------------------------

# A list of the source files that must be generated prior to dependency
# analysis.

GENERATED := installation.ml lexmli.ml lexer.ml parser.mli parser.ml		\
lineCount.ml lexdep.ml sentenceParser.mli sentenceParser.ml sentenceLexer.ml

# -------------------------------------------------------------------------

# A list of the modules that must be linked into the MenhirLib library.

# This library is used both at compile time (i.e., within Menhir itself)
# and at run time (i.e., it is made available to Menhir users, who need
# to link it with their own executables if they have used the --table
# option).

# If you change this list, please also update the files LICENSE and
# GNUmakefile in the toplevel directory.

LIBMODULES := infiniteArray packedIntArray rowDisplacement engineTypes	\
engine tableFormat tableInterpreter convert

# -------------------------------------------------------------------------

# A list of the modules that must be linked into the Menhir executable.

MODULES := menhirLib stringSet stringMap mark compressedBitSet		\
           unionFind tarjan patricia misc option breadth listMonad dot	\
           installation version settings time positions error		\
           parameters keyword lineCount printer rawPrinter action	\
           parserAux parser lexer partialGrammar parameterizedGrammar	\
           reachability unparameterizedPrinter preFront codeBits	\
           tokenType interface IO lexmli lexdep infer			\
           nonTerminalDefinitionInlining front grammar item lr0 lr1	\
           lr1partial derivation conflict invariant codePieces		\
           sentenceParser sentenceLexer pprint cst			\
           referenceInterpreter interpret tableBackend codeBackend	\
           traverse inliner back

# -------------------------------------------------------------------------

# How to bootstrap. Set TARGET to byte or opt depending on the desired
# architecture. In either case, the resulting executable is named
# menhir.

ifndef TARGET
  TARGET     := opt
endif

GOAL         := menhir.$(TARGET)

menhir: .versioncheck
# Build a stage one executable using ocamlyacc.
	$(MAKE) -s PGEN="$(CAMLYACC)" PARSER=parser $(GOAL)
# Remove the ocamlyacc-built parser.
	@/bin/rm -f parser.ml parser.mli
# Build a stage two executable using the stage one executable (which is overwritten).
	$(MAKE) -s PGEN="./$(GOAL) $(PGFLAGS)" PARSER=fancy-parser $(GOAL)
# Create a stage three parser and make sure that it is identical.
	@./$(GOAL) $(PGFLAGS) -b reference fancy-parser.mly 2>/dev/null
	@if diff parser.mli reference.mli 2>&1 >/dev/null ; then \
	  if diff parser.ml reference.ml 2>&1 >/dev/null ; then \
	    echo "Bootstrap successful." ; \
	  else \
	    echo "Bootstrap FAILED: the implementation files differ." && false ; \
          fi ; \
	else \
	  echo "Bootstrap FAILED: the interface files differ." && false ; \
	fi
	@rm -f reference.ml reference.mli
# Rename the stage two executable to the desired name.
# Use a symbolic link, so that further development builds implicitly update
# menhir.
	@ln -sf $(GOAL) menhir

# -------------------------------------------------------------------------

# Linking.

menhirLib.cmo menhirLib.cmi: $(LIBMODULES:=.cmo)
	$(CAMLC) $(BFLAGS) -pack -o menhirLib.cmo $^

menhirLib.cmx menhirLib.o: $(LIBMODULES:=.cmx)
	$(CAMLOPT) -pack -o menhirLib.cmx $^

menhir.byte: $(MODULES:=.cmo)
	$(CAMLC) -o $@ $(LNKBFLAGS) $(BLIBS) $^

menhir.opt: $(MODULES:=.cmx)
	$(CAMLOPT) -o $@ $(LNKOFLAGS) $(OLIBS) $^

# -------------------------------------------------------------------------

# Computing dependencies. This can be done in a simple way, even though
# we exploit --infer, because we compile in two stages. Not a good example
# of how to do it yourself -- have a look at demos/Makefile.shared.

# For completeness, we must force ocamldep to understand that MenhirLib
# is a module name. We do this by creating phantom source files for it.

.depend: $(wildcard *.ml *.mli) $(GENERATED)
	@/bin/rm -f .depend
	for i in *.ml *.mli; do \
           $(CAMLDEPWRAPPER) menhirLib.ml menhirLib.mli - $(CAMLDEP) $$i \
        >> $@; \
	done

ifeq ($(findstring $(MAKECMDGOALS),$(COLD)),)
-include .depend
endif

# -------------------------------------------------------------------------

# Cleaning up.

clean::
	/bin/rm -f menhir.byte menhir.opt menhir
	/bin/rm -f *.cmi *.cmx *.cmo *.o *.obj *~ .*~
	/bin/rm -f reference.ml reference.mli $(GENERATED)
	/bin/rm -f .depend *.conflicts *.automaton *.annot *.output

# -------------------------------------------------------------------------

# Compiling. The parser source is found in $(PARSER).mly and is
# processed using $(PGEN).

# These two default definitions really shouldn't be necessary, but
# there are corner cases where they are needed (e.g. when make is
# invoked without a target and the .depend file is regenerated).

ifndef PGEN
  PGEN       := $(CAMLYACC)
endif
ifndef PARSER
  PARSER     := parser
endif

%.cmi: %.mli
	$(CAMLC) $(BFLAGS) -c $<

%.cmo: %.ml
	$(CAMLC) $(BFLAGS) -c $<

# If the module that is being compiled is part of MenhirLib, add the
# -for-pack option to the command line. This is required only when
# compiling to native code (the bytecode compiler accepts but ignores
# this option).

PACK = $(shell if echo $(LIBMODULES) | grep $* >/dev/null ; then echo -for-pack MenhirLib ; else echo ; fi)

%.cmx %.o: %.ml
	$(CAMLOPT) $(OFLAGS) $(PACK) -c $<

# The source file for this parser varies. It is either parser.mly or
# fancy-parser.mly.
#
parser.ml parser.mli: $(PARSER).mly
	@/bin/rm -f parser.ml parser.mli
	$(PGEN) -b parser $<
	@/bin/chmod -w parser.ml parser.mli

# This parser must be built with ocamlyacc, because its client
# watches for Parsing.Parse_error!
#
# Using ocamlyacc or Menhir interchangeably would be possible,
# via an ocamlyacc wrapper that adds the definition "exception
# Error = Parsing.Parse_error" at the end of the generated .ml
# and .mli files.
#
sentenceParser.ml sentenceParser.mli : sentenceParser.mly
	@/bin/rm -f sentenceParser.ml sentenceParser.mli
	$(CAMLYACC) -b sentenceParser $<
	@/bin/chmod -w sentenceParser.ml sentenceParser.mli

%.ml: %.mll
	@/bin/rm -f $@
	$(CAMLLEX) $<
	@/bin/chmod -w $@

# ----------------------------------------------------------------------------
# Checking the version of the ocaml compiler.
#
# We check the bytecode compiler only, because some architectures don't have
# the native code compiler. We assume that both compilers, if present, are in
# sync.

# We build a bytecode executable (rather than use the toplevel loop) because
# we need to load str.cma and some ocaml ports do not support dynamic loading
# (e.g. ocaml 3.09, MacOS/Intel).

.versioncheck:
	@ echo Checking that Objective Caml is recent enough...
	@ $(CAMLC) -o check-ocaml-version str.cma checkOCamlVersion.ml
	@ ./check-ocaml-version --verbose --gt "3.09"
	@ rm check-ocaml-version
	@ touch .versioncheck

clean::
	rm -f .versioncheck

# -------------------------------------------------------------------------

# Building menhirLib.

ifeq ($(TARGET),byte)
lib: menhirLib.cmo menhirLib.cmi
else
lib: menhirLib.cmo menhirLib.cmi menhirLib.cmx menhirLib.o
endif

## menhir 20110201.dfsg

=== Makefile ===
--- 
+++ 
@@ -35,7 +35,16 @@
 MANS            := menhir.1
 DOCS            := manual.pdf demos
 MLYLIB          := src/standard.mly
+
+# -------------------------------------------------------------------------
+
+# Building menhirLib.
+
+ifeq ($(TARGET),byte)
+MENHIRLIB       := menhirLib.cmi menhirLib.cmo
+else
 MENHIRLIB       := menhirLib.cmi menhirLib.cmo menhirLib.cmx menhirLib.o
+endif
 
 # ----------------------------------------------------------------------------
 # Compilation.
@@ -46,7 +55,7 @@
 
 src/menhir: src/installation.ml
 	$(MAKE) -C src -f Makefile
-	$(MAKE) -C src -f Makefile lib
+	$(MAKE) -C src -f Makefile $(MENHIRLIB)
 
 # Record some installation time settings within the menhir binary.

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-.PHONY: clean lib
+.PHONY: clean
 
 COLD         += clean
 
@@ -204,7 +204,6 @@
 parser.ml parser.mli: $(PARSER).mly
 	@/bin/rm -f parser.ml parser.mli
 	$(PGEN) -b parser $<
-	@/bin/chmod -w parser.ml parser.mli
 
 # This parser must be built with ocamlyacc, because its client
 # watches for Parsing.Parse_error!
@@ -217,12 +216,10 @@
 sentenceParser.ml sentenceParser.mli : sentenceParser.mly
 	@/bin/rm -f sentenceParser.ml sentenceParser.mli
 	$(CAMLYACC) -b sentenceParser $<
-	@/bin/chmod -w sentenceParser.ml sentenceParser.mli
 
 %.ml: %.mll
 	@/bin/rm -f $@
 	$(CAMLLEX) $<
-	@/bin/chmod -w $@
 
 # ----------------------------------------------------------------------------
 # Checking the version of the ocaml compiler.
@@ -245,12 +242,3 @@
 clean::
 	rm -f .versioncheck
 
-# -------------------------------------------------------------------------
-
-# Building menhirLib.
-
-ifeq ($(TARGET),byte)
-lib: menhirLib.cmo menhirLib.cmi
-else
-lib: menhirLib.cmo menhirLib.cmi menhirLib.cmx menhirLib.o
-endif

## menhir 20120123.dfsg

=== src/Makefile ===
--- 
+++ 
@@ -1,6 +1,12 @@
 .PHONY: clean
 
 COLD         += clean
+
+# ----------------------------------------------------------------------------
+
+# A few settings differ on Windows versus Unix.
+
+include ../Makefile.arch
 
 # ----------------------------------------------------------------------------
 # Locating the ocaml compilers.
@@ -42,7 +48,7 @@
 LNKOFLAGS    :=
 BLIBS        := unix.cma
 OLIBS        := unix.cmxa
-PGFLAGS      := -v -lg 1 -la 1 -lc 1 --comment --infer --error-recovery --stdlib .
+PGFLAGS      := -v -lg 1 -la 1 -lc 1 --comment --infer --error-recovery --stdlib . --strict
 
 # -------------------------------------------------------------------------
 
@@ -71,32 +77,36 @@
 
 # A list of the modules that must be linked into the Menhir executable.
 
-MODULES := menhirLib stringSet stringMap mark compressedBitSet		\
-           unionFind tarjan patricia misc option breadth listMonad dot	\
-           installation version settings time positions error		\
-           parameters keyword lineCount printer rawPrinter action	\
-           parserAux parser lexer partialGrammar parameterizedGrammar	\
-           reachability unparameterizedPrinter preFront codeBits	\
-           tokenType interface IO lexmli lexdep infer			\
-           nonTerminalDefinitionInlining front grammar item lr0 lr1	\
-           lr1partial derivation conflict invariant codePieces		\
+MODULES := menhirLib Fix stringSet stringMap mark compressedBitSet	\
+           unionFind tarjan nonpositiveCycles patricia misc option	\
+           breadth listMonad dot installation version settings time	\
+           positions error parameters keyword lineCount printer		\
+           rawPrinter action parserAux parser lexer partialGrammar	\
+           parameterizedGrammar reachability unparameterizedPrinter	\
+           preFront codeBits tokenType interface IO lexmli lexdep	\
+           infer nonTerminalDefinitionInlining front grammar item lr0	\
+           slr lr1 lr1partial derivation conflict invariant codePieces	\
            sentenceParser sentenceLexer pprint cst			\
            referenceInterpreter interpret tableBackend codeBackend	\
-           traverse inliner back
-
-# -------------------------------------------------------------------------
-
-# How to bootstrap. Set TARGET to byte or opt depending on the desired
-# architecture. In either case, the resulting executable is named
-# menhir.
+           coqBackend traverse inliner back
+
+# -------------------------------------------------------------------------
+
+# How to bootstrap.
+
+# Set TARGET to byte or opt depending on the desired architecture.
 
 ifndef TARGET
   TARGET     := opt
 endif
 
+# The variable GOAL is the name of the executable file.
+
 GOAL         := menhir.$(TARGET)
 
-menhir: .versioncheck
+# We create a symbolic link of GOAL to MENHIREXE.
+
+$(MENHIREXE): .versioncheck
 # Build a stage one executable using ocamlyacc.
 	$(MAKE) -s PGEN="$(CAMLYACC)" PARSER=parser $(GOAL)
 # Remove the ocamlyacc-built parser.
@@ -118,7 +128,7 @@
 # Rename the stage two executable to the desired name.
 # Use a symbolic link, so that further development builds implicitly update
 # menhir.
-	@ln -sf $(GOAL) menhir
+	@ln -sf $(GOAL) $@
 
 # -------------------------------------------------------------------------
 
@@ -161,8 +171,8 @@
 # Cleaning up.
 
 clean::
-	/bin/rm -f menhir.byte menhir.opt menhir
-	/bin/rm -f *.cmi *.cmx *.cmo *.o *.obj *~ .*~
+	/bin/rm -f menhir.byte menhir.opt $(MENHIREXE)
+	/bin/rm -f *.cmi *.cmx *.cmo *.$(OBJ) *~ .*~
 	/bin/rm -f reference.ml reference.mli $(GENERATED)
 	/bin/rm -f .depend *.conflicts *.automaton *.annot *.output

## menhir 20130116.dfsg

=== Makefile ===
--- 
+++ 
@@ -18,6 +18,12 @@
 ifndef USE_OCAMLFIND
   USE_OCAMLFIND = ocamlfind ocamlc -v >/dev/null 2>&1
 endif
+
+# ----------------------------------------------------------------------------
+
+# A few settings differ on Windows versus Unix.
+
+include Makefile.arch
 
 # ----------------------------------------------------------------------------
 # Installation paths.
@@ -43,39 +49,37 @@
 ifeq ($(TARGET),byte)
 MENHIRLIB       := menhirLib.cmi menhirLib.cmo
 else
-MENHIRLIB       := menhirLib.cmi menhirLib.cmo menhirLib.cmx menhirLib.o
+MENHIRLIB       := menhirLib.cmi menhirLib.cmo menhirLib.cmx menhirLib.$(OBJ)
 endif
 
 # ----------------------------------------------------------------------------
 # Compilation.
 
+# Installation time settings are recorded within src/installation.ml.
+# This file is recreated every time so as to avoid becoming stale.
+
 .PHONY: all install uninstall
 
-all: src/menhir
-
-src/menhir: src/installation.ml
-	$(MAKE) -C src -f Makefile
-	$(MAKE) -C src -f Makefile $(MENHIRLIB)
-
-# Record some installation time settings within the menhir binary.
-
-src/installation.ml:
-	echo "let libdir = \"${libdir}\"" > $@
+all:
+	rm -f src/installation.ml
+	echo "let libdir = \"${libdir}\"" > src/installation.ml
 	if $(USE_OCAMLFIND) ; then \
-	  echo "let ocamlfind = true" >> $@ ; \
+	  echo "let ocamlfind = true" >> src/installation.ml ; \
 	else \
-	  echo "let ocamlfind = false" >> $@ ; \
+	  echo "let ocamlfind = false" >> src/installation.ml ; \
 	fi
+	$(MAKE) $(MFLAGS) -C src -f Makefile
+	$(MAKE) $(MFLAGS) -C src -f Makefile $(MENHIRLIB)
 
 # ----------------------------------------------------------------------------
 # Installation.
 
-install: src/menhir
+install: all
 	mkdir -p $(bindir)
 	mkdir -p $(libdir)
 	mkdir -p $(docdir)
 	mkdir -p $(mandir)
-	install src/menhir $(bindir)
+	install src/$(MENHIREXE) $(bindir)
 	install -m 644 $(MLYLIB) $(libdir)
 	cp -r $(DOCS) $(docdir)
 	cp -r $(MANS) $(mandir)
@@ -88,7 +92,7 @@
 	fi
 
 uninstall:
-	rm -rf $(bindir)/menhir
+	rm -rf $(bindir)/$(MENHIREXE)
 	rm -rf $(libdir)
 	rm -rf $(docdir)
 	rm -rf $(mandir)/$(MANS)
@@ -96,4 +100,3 @@
 	  echo Un-installing MenhirLib via ocamlfind. ; \
 	  ocamlfind remove menhirLib ; \
 	fi
-

=== demos/Makefile ===
DEMOS := calc calc-two calc-param

.PHONY: all clean

all:
	@for i in $(DEMOS) ; do \
	  $(MAKE) -C $$i ; \
	done

clean:
	/bin/rm -f *~ .*~ *.omc
	@for i in $(DEMOS) ; do \
	  $(MAKE) -C $$i clean ; \
	done

=== src/Makefile ===
--- 
+++ 
@@ -77,11 +77,27 @@
 
 # A list of the modules that must be linked into the Menhir executable.
 
+# Some of these modules have side effects and must be executed in the
+# following order:
+
+# Settings		parses the command line
+# PreFront		reads the grammar description files
+# TokenType		deals with --only-tokens and exits
+# Front			deals with --depend, --infer, --only-preprocess, and exits
+# Grammar		performs a number of analyses of the grammar
+# Lr0			constructs the LR(0) automaton
+# Slr			determines whether the grammar is SLR
+# Lr1			constructs the LR(1) automaton
+# Conflict		performs default conflict resolution and explains conflicts
+# Invariant		performs a number of analyses of the automaton
+# Interpret		deals with --interpret and exits
+# Back			produces the output and exits
+
 MODULES := menhirLib Fix stringSet stringMap mark compressedBitSet	\
-           unionFind tarjan nonpositiveCycles patricia misc option	\
+           unionFind tarjan patricia misc option	\
            breadth listMonad dot installation version settings time	\
            positions error parameters keyword lineCount printer		\
-           rawPrinter action parserAux parser lexer partialGrammar	\
+           action parserAux parser lexer partialGrammar	\
            parameterizedGrammar reachability unparameterizedPrinter	\
            preFront codeBits tokenType interface IO lexmli lexdep	\
            infer nonTerminalDefinitionInlining front grammar item lr0	\

=== demos/calc-param/Makefile ===
# Add --table on the next line to use Menhir's table-based back-end.
PGFLAGS         := --infer
GENERATED       := parser.ml parser.mli lexer.ml tokens.ml tokens.mli
MODULES         := parser lexer calc
EXECUTABLE      := calc
OCAMLDEPWRAPPER := ../ocamldep.wrapper
include ../Makefile.shared
$(eval $(call menhir_monomodule,tokens,--only-tokens))
$(eval $(call menhir_multimodule,parser,tokens.mly parser.mly,--external-tokens Tokens))

=== demos/calc-two/Makefile ===
# Add --table on the next line to use Menhir's table-based back-end.
PGFLAGS         := --infer
GENERATED       := tokens.ml tokens.mli algebraic.ml algebraic.mli reverse.ml reverse.mli lexer.ml
MODULES         := algebraic reverse lexer calc
EXECUTABLE      := calc
OCAMLDEPWRAPPER := ../ocamldep.wrapper
include ../Makefile.shared
$(eval $(call menhir_monomodule,tokens,--only-tokens))
$(eval $(call menhir_multimodule,algebraic,tokens.mly algebraic.mly common.mly,--external-tokens Tokens))
$(eval $(call menhir_multimodule,reverse,tokens.mly reverse.mly common.mly,--external-tokens Tokens))

=== demos/calc/Makefile ===
# Add --table on the next line to use Menhir's table-based back-end.
PGFLAGS         := --infer
GENERATED       := parser.ml parser.mli lexer.ml
MODULES         := parser lexer calc
EXECUTABLE      := calc
OCAMLDEPWRAPPER := ../ocamldep.wrapper
include ../Makefile.shared
include ../Makefile.auto

=== debian/changelog ===
menhir (20130116.dfsg-2) unstable; urgency=low

  * Team upload
  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Tue, 03 Dec 2013 00:42:01 +0100

menhir (20130116.dfsg-1) experimental; urgency=low

  * Team upload
  * New upstream release
  * Switch source package format to 3.0 (quilt)
  * Update Vcs-*
  * Compile with OCaml >= 4

 -- Stéphane Glondu <glondu@debian.org>  Wed, 24 Jul 2013 15:47:49 +0200

menhir (20120123.dfsg-1) unstable; urgency=low

  * New upstream release
    - fixes http://caml.inria.fr/mantis/view.php?id=5462

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 23 Jan 2012 20:50:25 +0100

menhir (20111019.dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #583291).
  * Bump Standards-Version to 3.9.2, no changes needed.

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 02 Jan 2012 18:05:48 +0100

menhir (20110201.dfsg-1) unstable; urgency=low

  [ Stéphane Glondu ]
  * Do not install examples twice (Closes: #603335)

  [ Mehdi Dogguy ]
  * New upstream release.
  * Set filter-pristine-tar to True in debian/gbp.conf.

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 16 Apr 2011 00:12:54 +0200

menhir (20090505.dfsg-2) unstable; urgency=low

  * Use new features of dh-ocaml (0.9).
  * Build-dep on ocaml >= 3.11.1-3~
  * Use new address and remove DMUA
  * Bump standards to 3.8.3
  * Convert patches to quilt format and use quilt instead of dpatch

 -- Mehdi Dogguy <mehdi@debian.org>  Wed, 23 Sep 2009 18:48:23 +0200

menhir (20090505.dfsg-1) unstable; urgency=low

  * New Upstream Version
  * More verbose description for libmenhir-ocaml-dev, Closes: #518666.
  * Move libmenhir-ocaml-dev to the new ocaml section.
  * Drop src_Makefile.dpatch: integrated upstream.
  * Build-dep on ocaml >= 3.11.1

 -- Mehdi Dogguy <dogguy@pps.jussieu.fr>  Wed, 24 Jun 2009 23:04:37 +0200

menhir (20090204.dfsg-2) unstable; urgency=low

  * New binary package libmenhir-ocaml-dev, Closes: #516134.
  * Use dh-ocaml predefined variables.
  * Use predefined variable OCAML_BEST (dh-ocaml >= 0.4).
  * debian/svn-deblayout: remove no longer needed SVN setting

 -- Mehdi Dogguy <dogguy@pps.jussieu.fr>  Sun, 22 Feb 2009 23:41:17 +0100

menhir (20090204.dfsg-1) experimental; urgency=low

  * New Upstream Version
  * Add dependency ${misc:Depends}, thanks zack.
  * Update src_Makefile.dpatch
  * Add DMUA flag with Sam's blessing. 
  * PREFIX is set back to /usr in debian/rules

 -- Mehdi Dogguy <dogguy@pps.jussieu.fr>  Thu, 19 Feb 2009 13:18:19 +0100

menhir (20080912.dfsg-2) experimental; urgency=low

  * Bump ocaml version to 3.11
  * Add build-dependency on dh-ocaml
  * Shorten debian/rules

 -- Mehdi Dogguy <dogguy@pps.jussieu.fr>  Wed, 18 Feb 2009 16:23:09 +0100

menhir (20080912.dfsg-1) experimental; urgency=low

  [ Mehdi Dogguy ]
  * New upstream release, (Closes: #500699).
  * Add myself to uploaders and set d-o-m as maintainer.
  * Bump standards version to 3.8.0, no changes needed.
  * Change Vcs-* flags to point to git repository.
  * Update debian/rules: All source files are now in src/
  * Bump debhelper compat to 7 and shorten debian/rules
  * Add src_Makefile.dpatch to not try to build cmx files on non-native
    architectures.
  * Add Homepage field to debian/control.
  * Install menhirLib
  * Remove ocamlfind from build-dependency: not used.

  [ Samuel Mimram ]
  * Mangle .dfsg in version in watch file.

 -- Mehdi Dogguy <dogguy@pps.jussieu.fr>  Fri, 23 Jan 2009 12:43:54 +0100

menhir (20071212.dfsg-1) unstable; urgency=low

  * New upstream release.
  * Updated standards version, no changes needed.

 -- Samuel Mimram <smimram@debian.org>  Sat, 22 Dec 2007 00:46:17 +0100

menhir (20071205.dfsg-1) unstable; urgency=low

  * New upstream release.
  * Tighten dependency on ocaml-nox.

 -- Samuel Mimram <smimram@debian.org>  Tue, 11 Dec 2007 00:45:36 +0000

menhir (20070520-2) unstable; urgency=low

  * Rebuild with OCaml 3.10.

 -- Samuel Mimram <smimram@debian.org>  Sat, 08 Sep 2007 01:30:14 +0200

menhir (20070520-1) unstable; urgency=low

  * New upstream release.

 -- Samuel Mimram <smimram@debian.org>  Mon, 23 Jul 2007 14:25:32 +0200

menhir (20070322.dfsg-4) unstable; urgency=low

  * Correcly clean, closes: #424571.

 -- Samuel Mimram <smimram@debian.org>  Tue, 22 May 2007 22:36:35 +0200

menhir (20070322.dfsg-3) unstable; urgency=low

  * Rebuild in bytecode when native compilation fails.

 -- Samuel Mimram <smimram@debian.org>  Wed, 18 Apr 2007 12:51:43 +0200

menhir (20070322.dfsg-2) unstable; urgency=low

  * Uploading to unstable.

 -- Samuel Mimram <smimram@debian.org>  Mon, 09 Apr 2007 17:53:02 +0200

menhir (20070322.dfsg-1) experimental; urgency=low

  * New upstream release.
  * Menhir is now correctly bootstrapped, closes: #397467.

 -- Samuel Mimram <smimram@debian.org>  Fri, 23 Mar 2007 00:14:31 +0100

menhir (20070215.dfsg-1) experimental; urgency=low

  * New upstream release.
  * Removed bashism.dpatch, integrated upstream.
  * Removed manpage, since it is now provided upstream.
  * Updated standards version to 3.7.2, no changes needed.

 -- Samuel Mimram <smimram@debian.org>  Wed, 28 Feb 2007 19:49:34 +0100

menhir (20060615.dfsg-2) unstable; urgency=low

  * Correctly set PREFIX when building, closes: #378260.
  * Added bashim.dpatch to remove bashisms, closes: #377803.

 -- Samuel Mimram <smimram@debian.org>  Tue, 11 Jul 2006 12:26:18 +0000

menhir (20060615.dfsg-1) unstable; urgency=low

  * Repackaged upstream's tarball to remove manual.pdf for which we don't have
    the sources (yet).

 -- Samuel Mimram <smimram@debian.org>  Sat,  8 Jul 2006 09:24:11 +0000

menhir (20060615-1) unstable; urgency=low

  * New upstream release.
  * Removed makefile.dpatch, found a better way to use the makefile.
  * Added manpage.dpatch to remove invalid characters from the manpage.
  * Updated standards version to 3.7.2, no changes needed.

 -- Samuel Mimram <smimram@debian.org>  Sat, 24 Jun 2006 19:06:02 +0000

menhir (20060412-1) unstable; urgency=low



=== debian/control ===
Source: menhir
Section: devel
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
  Samuel Mimram <smimram@debian.org>,
  Mehdi Dogguy <mehdi@debian.org>
Build-Depends:
  debhelper (>= 7.0.50),
  ocaml-nox (>= 4),
  dh-ocaml (>= 0.9)
Standards-Version: 3.9.2
Homepage: http://gallium.inria.fr/~fpottier/menhir/
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/menhir.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/menhir.git

Package: menhir
Architecture: any
Depends:
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
Description: Parser generator for OCaml
 Menhir is a LR(1) parser generator for OCaml. It is mostly compatible
 with the standard ocamlyacc and has the following enhancements:
  * it accepts LR(1) grammars,
  * it offers parameterized nonterminal symbols as well as a library of
    standard definitions,
  * it explains conflicts in terms of the grammar,
  * it allows grammar specifications to be split over multiple files and
    parametrized by OCaml modules,
  * it produces reentrant parsers.

Package: libmenhir-ocaml-dev
Section: ocaml
Architecture: any
Depends:
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
Provides:
  ${ocaml:Provides}
Description: Menhir library for OCaml
 This package contains the Menhir library for OCaml. It gives access to,
 among others, the following modules:
  * InfiniteArray: implements infinite arrays, that is, arrays
    that grow transparently upon demand.
  * RowDisplacement: compresses a two-dimensional table, where some
    values are considered insignificant, via row displacement.
  * Engine: LR parsing engine.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

DESTDIR := $(CURDIR)/debian/menhir

override_dh_auto_build:
	$(MAKE) TARGET=$(OCAML_BEST) PREFIX=/usr

override_dh_auto_clean:
	$(MAKE) -C src/ clean PREFIX=$(DESTDIR)/usr

override_dh_auto_install:
	cp src/menhir.$(OCAML_BEST) $(DESTDIR)/usr/bin/menhir

override_dh_auto_test:

%:
	dh --with ocaml $@

=== debian/watch ===
version=3

opts=dversionmangle=s/\.dfsg// \
        http://pauillac.inria.fr/~fpottier/menhir/menhir-(.*)\.tar\.gz

## menhir 20140422.dfsg

=== src/Makefile ===
.PHONY: everyday library bootstrap stage1 stage2 stage3 clean

# ----------------------------------------------------------------------------
# Choose a target.

ifndef TARGET
  TARGET := native
endif

# ----------------------------------------------------------------------------
# Define the files that form the library.

ifeq ($(TARGET),byte)
  LIBFILES := menhirLib.cmo
else
  LIBFILES := menhirLib.cmo menhirLib.cmx
endif

# ----------------------------------------------------------------------------
# Ocamlbuild tool and settings.

OCAMLBUILD := ocamlbuild -classic-display -j 0

# ----------------------------------------------------------------------------
# For everyday development.
# Typing "make" will perform just stage 1. This is enough to ensure that
# the source code is correct.

everyday: installation.ml stage1

# ----------------------------------------------------------------------------
# Building MenhirLib.

library:
	$(OCAMLBUILD) $(LIBFILES)

# ----------------------------------------------------------------------------
# Building Menhir from scratch (a.k.a. bootstrapping).

bootstrap: .versioncheck stage1 stage2 stage3

# ----------------------------------------------------------------------------
# Checking the version of the OCaml compiler.

.versioncheck:
	@ echo Checking that Objective Caml is recent enough...
	@$(OCAMLBUILD) -build-dir _stage1 checkOCamlVersion.byte
	@ _stage1/checkOCamlVersion.byte --verbose --gt "3.09"
	@ touch $@

# ----------------------------------------------------------------------------
# Stage 1.
# Build Menhir using ocamlyacc.

stage1:
	@$(OCAMLBUILD) -build-dir _stage1 -tag yacc_parser \
	  menhir.$(TARGET)

# ----------------------------------------------------------------------------
# Stage 2.
# Build Menhir using Menhir (from stage 1).

FLAGS := -v -lg 1 -la 1 -lc 1 --comment --infer --error-recovery --stdlib . --strict --fixed-exception

stage2:
	@$(OCAMLBUILD) -build-dir _stage2 -tag fancy_parser \
	  -use-menhir -menhir "$(shell pwd)/_stage1/menhir.$(TARGET) $(FLAGS)" \
	  menhir.$(TARGET)

# ----------------------------------------------------------------------------
# Stage 3 (optional).
# Re-generate Menhir's parser using Menhir (from stage 2) and check that it
# is identical to the stage 2 parser.
stage3:
	@$(OCAMLBUILD) -build-dir _stage3 -tag fancy_parser \
	  -use-menhir -menhir "$(shell pwd)/_stage2/menhir.$(TARGET) $(FLAGS)" \
	  parser.ml parser.mli
	@for i in parser.ml parser.mli ; do \
	  if ! diff _stage2/$$i _stage3/$$i 2>&1 >/dev/null ; then \
	    echo "Bootstrap FAILED: $$i did not reach a fixed point."; exit 1 ; \
	  fi ; \
	done; \
	echo "Bootstrap successful."

# ----------------------------------------------------------------------------
# Cleaning up.

clean::
	rm -rf .versioncheck _build _stage1 _stage2 _stage3

=== debian/changelog ===
menhir (20140422.dfsg-1) unstable; urgency=medium

  * New upstream relese.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 27 Apr 2014 14:49:45 +0200

menhir (20130911.dfsg-2) unstable; urgency=medium

  * Fix FTBFS on bytecode architectures.
    - Add 0002-Use-CURDIR-instead-of-.-during-bootstrap.patch
  * Do not install menhirLib.mlpack.

 -- Mehdi Dogguy <mehdi@debian.org>  Thu, 27 Mar 2014 20:53:44 +0100

menhir (20130911.dfsg-1) unstable; urgency=low

  * New upstream release.
  * Add ocaml-findlib to Build-Depends.
  * Use native/byte targets instead of $(OCAML_BEST)
  * Adapt install steps to new build system.

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 24 Mar 2014 22:38:20 +0100

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
 Build-Depends:
   debhelper (>= 7.0.50),
   ocaml-nox (>= 4),
+  ocaml-findlib,
   dh-ocaml (>= 0.9)
 Standards-Version: 3.9.2
 Homepage: http://gallium.inria.fr/~fpottier/menhir/

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

DESTDIR := $(CURDIR)/debian/menhir
BEST := native
ifneq ($(OCAML_BEST),opt)
BEST = byte
endif


override_dh_auto_build:
	$(MAKE) TARGET=$(BEST) PREFIX=/usr

override_dh_auto_clean:
	$(MAKE) -C src/ clean PREFIX=$(DESTDIR)/usr

override_dh_auto_install:
	cp src/_stage2/menhir.$(BEST) $(DESTDIR)/usr/bin/menhir

override_dh_auto_test:

%:
	dh --with ocaml $@
